/*
 * ----------------------------------------------------------------------
 * WARNING: THIS IS A BETA RELEASE OF LAM/MPI.  USERS ARE ADVISED TO USE
 * IT AT THEIR OWN RISK.  SEE THE MAIN WEB SITE
 * (http://www.mpi.nd.edu/lam/) FOR STABLE VERSIONS OF LAM/MPI.
 * ----------------------------------------------------------------------
 * 
 * Copyright 1998-2000, University of Notre Dame.
 * Authors: Jeffrey M. Squyres with Kinis L. Meyer, M. D. McNally,
 *          and Andrew Lumsdaine
 * 
 * This file is part of the BETA RELEASE of the Notre Dame LAM
 * implementation of MPI.
 * 
 * You should have received a copy of the License Agreement for the Notre
 * Dame LAM implementation of MPI along with the software; see the file
 * LICENSE.  If not, contact Office of Research, University of Notre
 * Dame, Notre Dame, IN 46556.
 * 
 * Permission to modify the code and to distribute modified code is
 * granted, provided the text of this NOTICE is retained, a notice that
 * the code was modified is included with the above COPYRIGHT NOTICE and
 * with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
 * file is distributed with the modified code.
 * 
 * LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
 * By way of example, but not limitation, Licensor MAKES NO
 * REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
 * PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
 * OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
 * OR OTHER RIGHTS.
 * 
 * Additional copyrights may follow.
 * 
 *	Ohio Trollius
 *	Copyright 1996 The Ohio State University
 *	RBD
 *
 *	$Id: wtime.c,v 6.3 1999/12/31 21:27:43 jsquyres Exp $
 *
 *	Function:	- return wall clock time
 *	Returns:	- wall clock time in seconds
 */

#include <mpi.h>
#include <mpisys.h>
#include <net.h>

/*@
MPI_Wtime - Returns an elapsed time on the calling processor

Return value:

Time in seconds since an arbitrary time in the past.

Notes:

This is intended to be a high-resolution, elapsed (or wall) clock.
See 'MPI_Wtick' to determine the resolution of 'MPI_Wime'.  If the
attribute 'MPI_WTIME_IS_GLOBAL' is defined and true, then the value is
synchronized across all processes in 'MPI_COMM_WORLD'.

Notes for Fortran:

This function is declared as 'DOUBLE PRECISION MPI_WTIME()' in
Fortran.

.seealso: MPI_Wtick, MPI_Comm_get_attr

.N ACK
@*/
double MPI_Wtime(void)
{
	return(ttime());
}
